zoukankan      html  css  js  c++  java
  • POJ 3311 Hie with the Pie 最短路+状压DP

    Hie with the Pie

    Time Limit: 2000MS   Memory Limit: 65536K
    Total Submissions: 11243   Accepted: 5963

    Description

    The Pizazz Pizzeria prides itself in delivering pizzas to its customers as fast as possible. Unfortunately, due to cutbacks, they can afford to hire only one driver to do the deliveries. He will wait for 1 or more (up to 10) orders to be processed before he starts any deliveries. Needless to say, he would like to take the shortest route in delivering these goodies and returning to the pizzeria, even if it means passing the same location(s) or the pizzeria more than once on the way. He has commissioned you to write a program to help him.

    Input

    Input will consist of multiple test cases. The first line will contain a single integer n indicating the number of orders to deliver, where 1 ≤ n ≤ 10. After this will be n + 1 lines each containing n + 1 integers indicating the times to travel between the pizzeria (numbered 0) and the n locations (numbers 1 to n). The jth value on the ith line indicates the time to go directly from location i to location j without visiting any other locations along the way. Note that there may be quicker ways to go from i to j via other locations, due to different speed limits, traffic lights, etc. Also, the time values may not be symmetric, i.e., the time to go directly from location i to j may not be the same as the time to go directly from location j to i. An input value of n = 0 will terminate input.

    Output

    For each test case, you should output a single number indicating the minimum time to deliver all of the pizzas and return to the pizzeria.

    Sample Input

    3
    0 1 10 10
    1 0 1 2
    10 1 0 10
    10 2 10 0
    0

    Sample Output

    8
    题目大意: 
    一个送外卖的人,从0点出发,要经过所有的地点然后再回到店里(就是0点),求最少花费的代价。 
    输入 
    1<=n<=10 ,n表示要去的n个地点,包括店里(0点)一共右n+1个点
    接下来n+1行用矩阵来描述路径,用map[i][j]存储,表示从i到j的距离为map[i][j]

    题解:
    1、暴力:

    因为要经过所有的点,直接用dfs或最短路径来求肯定是不行的,要枚举第一个到达的点的所有情况,每种情况都有不同路径。例如有3个点,假设1为第一个到达的点,那么不同的顺序有0->1->2->3->0
    0->1->3->2->0
    所以时间复杂度为o(n!)
    2、最短路+DP
    仔细观察搜索解法的过程,其实是有很多重复计算的。
    比如从0点出发,经过1,2,3,4,5点后回到0点。那么
    0->1->2->(3,4,5三个点的排列)->0与
    0->2->1->(3,4,5三个点的排列)->0
    就存在重复计算3,4,5三点的排列)->0路径集上的最短路径。只要我们能够将这些状态保存下来就能够降低一部分复杂度。DP实现

    状态压缩:对所有的点543210,可以用一个长度为6的二进制数表示,对去过的点可以用1来表示,没有去过的点用0表示,显然,二进制数可以很好的储存走过的状态
    比如说:0->1->2->5,对应的二进制数为100111,存储的时用十进制数存储,100111对应的十进制数是39

    dp[i][j]表示i这个状态下,目标是j的最短路,这里的i就是压缩的状态,是用二进制表示每个地点是否去过(在i状态下到达的点已经包含点j)
        用floyd求最短路径,dis[i][j]表示点i到目标点j的最短路径

    状态转移方程:dp[i][j] = min(dp[i][j],dp[i'][k]+dis[k][j])。 i’表示i的不包含j的子集,dis[k][j]表示从k到j的最短距离。

    #include<iostream>
    #include <stdio.h>
    #include <string.h>
    using namespace std;
     //dp[i][j]表示i这个状态下,目标是j的最短路,这里的i就压缩的状态,是用二进制表示每个地点是否去过,
    //注意:在i状态下到达的点已经包含点j
    int map[20][20],dis[20][20],dp[1<<11][20];//map记录路径,dis[i][j]记录点i到j的最短路
     
    int main()
    {
        int n,i,j,k;
        while(~scanf("%d",&n))//包括0点,一个有n+1个点要去
        {
            if(n==0)
                break;
            for(i = 0; i<=n; i++)
                for(j = 0; j<=n; j++)
                {
                    scanf("%d",&map[i][j]);
                    dis[i][j] = map[i][j];//初始化dis[i][j]的值
                }
            for(j = 0; j<=n; j++)
            {
                for(i = 0; i<=n; i++)
                {
                    for(k = 0; k<=n; k++)
                    {
                        if(dis[i][j]>dis[i][k]+map[k][j])//更新dis
                            dis[i][j] = dis[i][k]+map[k][j];
                    }
                }
            }
            
            memset(dp,-1,sizeof(dp));
            dp[1][0] = 0;//表示从第0个点到第0个点的距离为0
            for(i = 1; i<1<<(n+1); i++)
            {
                i = i|1;//改变状态,表示第i点去过
                for(j = 0; j<=n; j++)
                {
                    if(dp[i][j]!=-1)//在i状态下,点j已经去过,距离为dp[i][j],但还要考虑i状态是否是最短
                    {
                        for(k = 0; k<=n; k++)//遍历,k点是i状态要经过的下一个点
                        {
                            //(1<<k)|i,将数字i在二进制下从右往左的第k+1位更改成1,表示经过这个点
                            if(j!=k && (dp[(1<<k)|i][k]==-1 || dp[(1<<k)|i][k]>dp[i][j]+dis[j][k]))
                        //如果i状态下,k点还未经过,或者已经过k点的距离比dp[i][j]+dis[j][k]的距离大,这里的点dp[i][j]是还未过k点的状态
                                dp[(1<<k)|i][k]=dp[i][j]+dis[j][k];
                        }
                    }
                }
            }
            printf("%d
    ",dp[(1<<(n+1))-1][0]);//(1<<(n+1))所有点都去过,并且最后回到0点
        }
     
        return 0;
    }


  • 相关阅读:
    哪里错了
    任性
    【转】JVM 堆最大能调多大?
    【Android】PA4D_CH7 文件、保存状态和首选项
    【Android】PA4D_CH6 使用Internat资源
    Think In Java 多态学习
    【转】Myeclipse 查看Jar文件里面源码中文乱码 问题解决
    [转载]getBoundClientRect函数详解
    Kettle 环境变量设置
    SQL Server 2012 不支持创建连接服务器到 2000 版本,及其替代方案
  • 原文地址:https://www.cnblogs.com/-citywall123/p/10885227.html
Copyright © 2011-2022 走看看